#include "core/Image.h"

#include <core/Utility.h>
#define STB_IMAGE_IMPLEMENTATION
#define STBI_ONLY_PNG
#define STBI_MALLOC(n) coreAllocate(n)
#define STBI_REALLOC(p, n) coreReallocate(p, n)
#define STBI_FREE(p) coreFree(p)
#include <core/Logger.h>
#include <errno.h>
#include <stb_image.h>
#include <string.h>

static void printError(const char* path) {
    CORE_LOG_ERROR("Cannot read image '%s': %s", path, strerror(errno));
}

bool coreInitImage8(CoreImage8* image, const char* path) {
    *image = (CoreImage8){0};
    image->data =
        stbi_load(path, &image->width, &image->height, &image->channels, 0);
    if(image->data == nullptr) {
        printError(path);
        return true;
    }
    return false;
}

void coreDestroyImage8(CoreImage8* image) {
    stbi_image_free(image->data);
    *image = (CoreImage8){0};
}

bool coreInitImage16(CoreImage16* image, const char* path) {
    *image = (CoreImage16){0};
    image->data =
        stbi_load_16(path, &image->width, &image->height, &image->channels, 0);
    if(image->data == nullptr) {
        printError(path);
        return true;
    }
    return false;
}

void coreDestroyImage16(CoreImage16* image) {
    stbi_image_free(image->data);
    *image = (CoreImage16){0};
}
